#!/usr/bin/perl

package Exim::Message::Action;

require 5;

use strict;
use integer;
use Carp;
use Exim;
use Exim::Message;

use vars qw(@ISA);

@ISA = qw(Exim Exim::Message);

sub _init_
  {
    my $self = shift;

    $self->result('buffer');
    my $msg = Exim::Message->new( $self->_exec(-bp => shift) );

    defined $msg or return undef;

    # Ugly....
    foreach my $key (keys %{$msg}) { $$self{$key} = $$msg{$key} }

    return $self
  }

sub new
  {
    my $class = shift;
    $class = ref($class) || $class;
    my %params = @_;

    my $self = Exim->new(%params);
    return undef if not defined $self;

    bless $self, $class;

    if (defined $params{uli}) {
      _init_($self, $params{uli}) or return undef;
    }
  }

sub deliver
  {
    my $self = shift;

    return $self->_exec(-M => $$self{uli});
  }

sub freeze
  {
    my $self = shift;

    return $self->_exec(-Mf => $$self{uli});
  }

sub thaw
  {
    my $self = shift;

    return $self->_exec(-Mt => $$self{uli});
  }

sub give_up
  {
    my $self = shift;

    return $self->_exec(-Mg => $$self{uli});
  }

sub remove
  {
    my $self = shift;

    return $self->_exec(-Mrm => $$self{uli});
  }

sub view_body
  {
    my $self = shift;

    return $self->_exec(-Mvb => $$self{uli});
  }

sub view_log
  {
    my $self = shift;

    return $self->_exec(-Mvl => $$self{uli});
  }

sub view_headers
  {
    my $self = shift;

    return $self->_exec(-Mvh => $$self{uli});
  }

sub add_recipients
  {
    my $self = shift;

    return $self->_exec(-Mar => $$self{uli}, @_);
  }

sub edit_sender
  {
    my $self = shift;
    return $self->_exec('-Mes', $$self{uli}, shift());
  }

sub mark_delivered
  {
    my $self = shift;

    return $self->_exec(-Mmd => $$self{uli}, @_);
  }

sub mark_all_delivered
  {
    my $self = shift;

    return $self->_exec(-Mmad => $$self{uli});
  }

